/*
 * Copyright 2021 peter.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package hk.quantr.veriloggraph;

import hk.quantr.mxgraph.canvas.mxICanvas;
import hk.quantr.mxgraph.canvas.mxImageCanvas;
import hk.quantr.mxgraph.layout.hierarchical.mxHierarchicalLayout;
import hk.quantr.mxgraph.layout.mxCircleLayout;
import hk.quantr.mxgraph.layout.mxCompactTreeLayout;
import hk.quantr.mxgraph.layout.mxEdgeLabelLayout;
import hk.quantr.mxgraph.layout.mxFastOrganicLayout;
import hk.quantr.mxgraph.layout.mxOrganicLayout;
import hk.quantr.mxgraph.layout.mxParallelEdgeLayout;
import hk.quantr.mxgraph.layout.mxStackLayout;
import hk.quantr.mxgraph.layout.orthogonal.mxOrthogonalLayout;
import hk.quantr.mxgraph.model.mxCell;
import hk.quantr.mxgraph.model.mxGeometry;
import hk.quantr.mxgraph.swing.mxGraphOutline;
import hk.quantr.mxgraph.util.mxConstants;
import hk.quantr.mxgraph.util.mxPoint;
import hk.quantr.mxgraph.view.mxCellState;
import hk.quantr.mxgraph.view.mxEdgeStyle;
import hk.quantr.mxgraph.view.mxGraph;
import hk.quantr.javalib.CommonLib;
import hk.quantr.verilogcompiler.VerilogHelper;
import hk.quantr.verilogcompiler.antlr.VerilogLexer;
import hk.quantr.verilogcompiler.antlr.VerilogParser;
import hk.quantr.verilogcompiler.listener.AllModuleListener;
import hk.quantr.verilogcompiler.listener.SingleModuleListener;
import hk.quantr.verilogcompiler.macro.ParseStructure;
import hk.quantr.verilogcompiler.structure.Module;
import hk.quantr.verilogcompiler.structure.Port;
import hk.quantr.verilogcompiler.structure.Wire;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;
import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.JColorChooser;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import org.antlr.v4.runtime.CommonTokenStream;
import org.antlr.v4.runtime.CharStreams;
import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.tuple.ImmutablePair;

public final class QuantrVerilogGraphPanel extends JPanel {

	mxGraph graph;
	MyGraphComponent graphComponent;
	mxGraphOutline graphOutline;
	HashMap<String, mxCell> moduleCells = new HashMap();
	HashMap<Wire, ArrayList<mxCell>> wireCells = new HashMap();
	HashMap<ImmutablePair<String, String>, mxCell> modulePortCells = new HashMap();
	HashMap<ImmutablePair<String, String>, Port> modulePortPorts = new HashMap();
	Module topModule;

	public QuantrVerilogGraphPanel() {
		initComponents();
		topModuleComboBox.setRenderer(new DefaultListCellRenderer() {

			@Override
			public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
				String text = null;
				if (value != null) {
					text = ((File) value).getName();
				}
				return super.getListCellRendererComponent(list, text, index, isSelected, cellHasFocus);
			}
		});

		moduleList.setCellRenderer(new DefaultListCellRenderer() {

			@Override
			public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
				Module module = (Module) value;
				return super.getListCellRendererComponent(list, module.name, index, isSelected, cellHasFocus);
			}
		});

		initJGraph();
		addLayoutMenuitems();
		jLabel2.setVisible(false);
		topModuleComboBox.setVisible(false);
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jToolBar1 = new javax.swing.JToolBar();
        reloadButton = new javax.swing.JButton();
        zoomInButton = new javax.swing.JButton();
        zoomToFitButton = new javax.swing.JButton();
        zoomTo100Button = new javax.swing.JButton();
        zoomOutButton = new javax.swing.JButton();
        layoutButton = new hk.quantr.javalib.swing.advancedswing.jdropdownbutton.JDropDownButton();
        jLabel2 = new javax.swing.JLabel();
        topModuleComboBox = new javax.swing.JComboBox<>();
        jLabel1 = new javax.swing.JLabel();
        fontSizeComboBox = new javax.swing.JComboBox<>();
        searchTextField = new javax.swing.JTextField();
        colorButton = new javax.swing.JButton();
        mainPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        rightPanel = new javax.swing.JPanel();
        infoLabel = new javax.swing.JLabel();
        wireLabel = new javax.swing.JLabel();
        destLabel = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        moduleList = new javax.swing.JList<>();

        setLayout(new java.awt.BorderLayout());

        jToolBar1.setRollover(true);

        reloadButton.setText("Reload");
        reloadButton.setFocusable(false);
        reloadButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        reloadButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        reloadButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reloadButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(reloadButton);

        zoomInButton.setText("Zoom In");
        zoomInButton.setFocusable(false);
        zoomInButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        zoomInButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        zoomInButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zoomInButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(zoomInButton);

        zoomToFitButton.setText("Fit");
        zoomToFitButton.setFocusable(false);
        zoomToFitButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        zoomToFitButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        zoomToFitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zoomToFitButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(zoomToFitButton);

        zoomTo100Button.setText("100%");
        zoomTo100Button.setFocusable(false);
        zoomTo100Button.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        zoomTo100Button.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        zoomTo100Button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zoomTo100ButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(zoomTo100Button);

        zoomOutButton.setText("Zoom Out");
        zoomOutButton.setFocusable(false);
        zoomOutButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        zoomOutButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        zoomOutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zoomOutButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(zoomOutButton);

        layoutButton.setFocusable(false);
        layoutButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        layoutButton.setMaximumSize(new java.awt.Dimension(200, 30));
        layoutButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        layoutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                layoutButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(layoutButton);

        jLabel2.setText("Top Module");
        jLabel2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 10, 0, 10));
        jToolBar1.add(jLabel2);

        topModuleComboBox.setMaximumSize(new java.awt.Dimension(250, 30));
        topModuleComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                topModuleComboBoxActionPerformed(evt);
            }
        });
        jToolBar1.add(topModuleComboBox);

        jLabel1.setText("Font Size");
        jToolBar1.add(jLabel1);

        fontSizeComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "10", "12", "14", "16", "20", "26", "32" }));
        fontSizeComboBox.setSelectedItem("16");
        fontSizeComboBox.setMaximumSize(new java.awt.Dimension(80, 30));
        fontSizeComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fontSizeComboBoxActionPerformed(evt);
            }
        });
        jToolBar1.add(fontSizeComboBox);

        searchTextField.setMaximumSize(new java.awt.Dimension(200, 30));
        searchTextField.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                searchTextFieldMouseClicked(evt);
            }
        });
        searchTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                searchTextFieldKeyTyped(evt);
            }
        });
        jToolBar1.add(searchTextField);

        colorButton.setBackground(new java.awt.Color(255, 0, 0));
        colorButton.setText(" ");
        colorButton.setFocusable(false);
        colorButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        colorButton.setOpaque(true);
        colorButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        colorButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                colorButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(colorButton);

        add(jToolBar1, java.awt.BorderLayout.NORTH);

        mainPanel.setLayout(new java.awt.BorderLayout());
        add(mainPanel, java.awt.BorderLayout.CENTER);

        jPanel1.setLayout(new java.awt.BorderLayout());

        rightPanel.setLayout(new javax.swing.BoxLayout(rightPanel, javax.swing.BoxLayout.Y_AXIS));

        infoLabel.setText("-");
        infoLabel.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        rightPanel.add(infoLabel);

        wireLabel.setText("-");
        wireLabel.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        rightPanel.add(wireLabel);

        destLabel.setText("-");
        destLabel.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        rightPanel.add(destLabel);

        jPanel1.add(rightPanel, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.BorderLayout());

        moduleList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                moduleListMouseClicked(evt);
            }
        });
        moduleList.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                moduleListKeyReleased(evt);
            }
        });
        jScrollPane1.setViewportView(moduleList);

        jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

        add(jPanel1, java.awt.BorderLayout.LINE_END);
    }// </editor-fold>//GEN-END:initComponents

//	private static void morphGraph(mxGraph graph, mxGraphComponent graphComponent) {
//		// define layout
//		mxIGraphLayout layout = new mxFastOrganicLayout(graph);
//
//		// layout using morphing
//		graph.getModel().beginUpdate();
//		try {
//			layout.execute(graph.getDefaultParent());
//		} finally {
//			mxMorphing morph = new mxMorphing(graphComponent, 20, 1.5, 20);
//
//			morph.addListener(mxEvent.DONE, new mxIEventListener() {
//
//				@Override
//				public void invoke(Object arg0, mxEventObject arg1) {
//					graph.getModel().endUpdate();
//					// fitViewport();
//				}
//
//			});
//			morph.startAnimation();
//		}
//	}

    private void zoomOutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomOutButtonActionPerformed
		graphComponent.zoomOut();
    }//GEN-LAST:event_zoomOutButtonActionPerformed

    private void zoomInButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomInButtonActionPerformed
		graphComponent.zoomIn();
    }//GEN-LAST:event_zoomInButtonActionPerformed

    private void layoutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_layoutButtonActionPerformed
		String str = layoutButton.getText();
		if (str.equals("Quantr Layout")) {
			Object[] vertices = graph.getChildVertices(graph.getDefaultParent());
			for (Object vertex : vertices) {
				System.out.println(vertex.getClass());
				mxCell vertexCell = (mxCell) vertex;
				System.out.println(vertexCell.getValue().getClass());

				Object[] temp = graph.getAllEdges(new mxCell[]{vertexCell});
				for (Object edge : temp) {
					System.out.println("\t" + edge);
					mxCell edgeCell = (mxCell) edge;
					Wire wire = (Wire) edgeCell.getValue();
					System.out.println("\t" + wire.name);
					mxCellState[] cellStates = graph.getView().getCellStates(new mxCell[]{edgeCell});
					if (cellStates.length > 0) {
						cellStates[0].getAbsolutePoints().add(new mxPoint(10, 10));
						for (mxPoint point : cellStates[0].getAbsolutePoints()) {
							System.out.println("\t\t\t" + (int) point.getX() + ", " + (int) point.getY());
						}
					}

//					for (mxCellState state : cellStates) {
//						System.out.println("\t\t" + state);
//						state.getAbsolutePoints().add(new mxPoint(10, 10));
//						System.out.println("\t\t\t" + state);
//					}
				}
			}
//			graph.getView().validate();
			graph.repaint();
		} else if (str.equals("Hierarchical Layout")) {
			mxHierarchicalLayout layout = new mxHierarchicalLayout(graph);
			layout.setDisableEdgeStyle(false);
//			layout.execute(cell);
			layout.execute(graph.getDefaultParent());
		} else if (str.equals("Circle Layout")) {
			mxCircleLayout layout = new mxCircleLayout(graph);
//			layout.execute(cell);
			layout.execute(graph.getDefaultParent());
		} else if (str.equals("Organic Layout")) {
			mxOrganicLayout layout = new mxOrganicLayout(graph);
			layout.setDisableEdgeStyle(false);
//			layout.execute(cell);
			layout.execute(graph.getDefaultParent());
		} else if (str.equals("Compact Tree Layout")) {
			mxCompactTreeLayout layout = new mxCompactTreeLayout(graph, true);
//			layout.execute(cell);
			layout.execute(graph.getDefaultParent());
		} else if (str.equals("Edge Label Layout")) {
			mxEdgeLabelLayout layout = new mxEdgeLabelLayout(graph);
//			layout.execute(cell);
			layout.execute(graph.getDefaultParent());
		} else if (str.equals("Fast Organic Layout")) {
			mxFastOrganicLayout layout = new mxFastOrganicLayout(graph);
			layout.setDisableEdgeStyle(false);
//			layout.execute(cell);
			layout.execute(graph.getDefaultParent());
		} else if (str.equals("Orthogonal Layout")) {
			mxOrthogonalLayout layout = new mxOrthogonalLayout(graph);
//			layout.execute(cell);
			layout.execute(graph.getDefaultParent());
		} else if (str.equals("Parallel Edge Layout")) {
			mxParallelEdgeLayout layout = new mxParallelEdgeLayout(graph);
			layout.execute(graph.getDefaultParent());
		} else if (str.equals("Stack Layout")) {
			mxStackLayout layout = new mxStackLayout(graph);
//			layout.execute(cell);
			layout.execute(graph.getDefaultParent());
		} else {
			System.out.println("no this layout");
		}

//		mxMorphing morph = new mxMorphing(graphComponent, 20, 1.2, 20);
//		morph.addListener(mxEvent.DONE, new mxIEventListener() {
//			public void invoke(Object sender, mxEventObject evt) {
//				graph.getModel().endUpdate();
//			}
//		});
//
//		morph.startAnimation();
    }//GEN-LAST:event_layoutButtonActionPerformed

    private void reloadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reloadButtonActionPerformed
		loadAllVerilog((File) topModuleComboBox.getSelectedItem());
    }//GEN-LAST:event_reloadButtonActionPerformed

    private void topModuleComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_topModuleComboBoxActionPerformed
		initJGraphComponent(topModule);
    }//GEN-LAST:event_topModuleComboBoxActionPerformed

    private void zoomToFitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomToFitButtonActionPerformed
		double difference = (graphComponent.getWidth() - 25) / graph.getGraphBounds().getWidth();
		setZoomFactor((graph.getView().getScale() * 100) * difference);
    }//GEN-LAST:event_zoomToFitButtonActionPerformed

    private void zoomTo100ButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomTo100ButtonActionPerformed
		graphComponent.zoomTo(1, false);
    }//GEN-LAST:event_zoomTo100ButtonActionPerformed

    private void moduleListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_moduleListMouseClicked
		initJGraphComponent(topModule);
    }//GEN-LAST:event_moduleListMouseClicked

    private void moduleListKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_moduleListKeyReleased
		initJGraphComponent(topModule);
    }//GEN-LAST:event_moduleListKeyReleased

    private void fontSizeComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fontSizeComboBoxActionPerformed
		this.reloadButtonActionPerformed(evt);
    }//GEN-LAST:event_fontSizeComboBoxActionPerformed

    private void searchTextFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_searchTextFieldKeyTyped
		PeterSwingCanvas myCanvas = (PeterSwingCanvas) graphComponent.getCanvas();
		myCanvas.selectedCells.clear();

		ArrayList<Wire> matchedWires = new ArrayList<>();
		if (!searchTextField.getText().equals("")) {
			for (Wire wire : topModule.wires.values()) {
				if (wire.name.toLowerCase().contains(searchTextField.getText().toLowerCase())) {
					matchedWires.add(wire);
				}
			}

			// highlight related ports
			for (ImmutablePair<String, String> key : modulePortCells.keySet()) {
				if (key.right.toLowerCase().contains(searchTextField.getText().toLowerCase())) {
					mxCell tempCell = modulePortCells.get(key);
					myCanvas.selectedCells.add(tempCell);

					for (Wire wire : topModule.wires.values()) {
						if (wire.ports.contains(modulePortPorts.get(key))) {
							matchedWires.add(wire);
						}
					}
				}
			}
			// end highlight related ports
		}

		// highlight related ports by wire
		for (Wire matchedWire : matchedWires) {
			for (Port p : matchedWire.ports) {
				mxCell tempCell = modulePortCells.get(new ImmutablePair(p.module.name, p.name));
				myCanvas.selectedCells.add(tempCell);
			}
		}
		// end highlight related ports by wire

		resetAllWiresColor();

		// highlight related wires
		for (Wire matchedWire : matchedWires) {
			for (mxCell matchedWireCell : wireCells.get(matchedWire)) {
				matchedWireCell.setStyle(matchedWireCell.getStyle().replaceAll("strokeColor=#[0-9a-fA-F]{6}", "strokeColor=" + CommonLib.toHexColor(colorButton.getBackground())));
				matchedWireCell.setStyle(matchedWireCell.getStyle().replaceAll("fontColor=#[0-9a-fA-F]{6}", "fontColor=" + CommonLib.toHexColor(colorButton.getBackground())));
				matchedWireCell.setStyle(matchedWireCell.getStyle().replaceAll("strokeWidth=[0-9]+", "strokeWidth=5"));
			}
		}
		// end highlight related wires

		graph.refresh();
    }//GEN-LAST:event_searchTextFieldKeyTyped

    private void searchTextFieldMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_searchTextFieldMouseClicked
		searchTextFieldKeyTyped(null);
    }//GEN-LAST:event_searchTextFieldMouseClicked

    private void colorButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_colorButtonActionPerformed
		Color color = JColorChooser.showDialog(null, "Dialog Title", colorButton.getBackground());
		colorButton.setBackground(color);
		((PeterSwingCanvas) graphComponent.getCanvas()).highlightBackground = color;
		searchTextFieldMouseClicked(null);
    }//GEN-LAST:event_colorButtonActionPerformed

	private void setZoomFactor(Double factor) {
		if (factor != null) {
			factor /= 100;
			if (factor != graph.getView().getScale()) {
				graphComponent.zoomTo(factor, false);
			}
		}
	}
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton colorButton;
    private javax.swing.JLabel destLabel;
    private javax.swing.JComboBox<String> fontSizeComboBox;
    private javax.swing.JLabel infoLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JToolBar jToolBar1;
    private hk.quantr.javalib.swing.advancedswing.jdropdownbutton.JDropDownButton layoutButton;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JList<Module> moduleList;
    private javax.swing.JButton reloadButton;
    private javax.swing.JPanel rightPanel;
    private javax.swing.JTextField searchTextField;
    public javax.swing.JComboBox<File> topModuleComboBox;
    private javax.swing.JLabel wireLabel;
    private javax.swing.JButton zoomInButton;
    private javax.swing.JButton zoomOutButton;
    private javax.swing.JButton zoomTo100Button;
    private javax.swing.JButton zoomToFitButton;
    // End of variables declaration//GEN-END:variables

	private void addLayoutMenuitems() {
		layoutButton.removeAll();
		layoutButton.add(new JMenuItem("Quantr Layout"));
		layoutButton.add(new JMenuItem("Hierarchical Layout"));
		layoutButton.add(new JMenuItem("Circle Layout"));
		layoutButton.add(new JMenuItem("Organic Layout"));
		layoutButton.add(new JMenuItem("Compact Tree Layout"));
		layoutButton.add(new JMenuItem("Edge Label Layout"));
		layoutButton.add(new JMenuItem("Fast Organic Layout"));
		layoutButton.add(new JMenuItem("Orthogonal Layout"));
		layoutButton.add(new JMenuItem("Parallel Edge Layout"));
		layoutButton.add(new JMenuItem("Stack Layout"));
		layoutButton.setText("Quantr Layout");
	}

	private void resetAllWiresColor() {
		// reset all wires color
		if (topModule != null) {
			for (Wire wire : topModule.wires.values()) {
				for (mxCell tempCell : wireCells.get(wire)) {
					tempCell.setStyle(tempCell.getStyle().replaceAll("strokeColor=#[0-9a-fA-F]{6}", "strokeColor=" + genColor(wire.name)));
					tempCell.setStyle(tempCell.getStyle().replaceAll("fontColor=#[0-9a-fA-F]{6}", "fontColor=" + genColor(wire.name)));
					tempCell.setStyle(tempCell.getStyle().replaceAll("strokeWidth=[0-9]+", "strokeWidth=1"));
				}
			}
		}
		// end reset all wires color
	}

	private void initJGraph() {
		graph = new mxGraph() {
			@Override
			public void drawState(mxICanvas canvas, mxCellState state, boolean drawLabel) {
				String label = (drawLabel) ? state.getLabel() : "";

				if (getModel().isVertex(state.getCell()) && canvas instanceof mxImageCanvas && ((mxImageCanvas) canvas).getGraphicsCanvas() instanceof PeterSwingCanvas) {
					((PeterSwingCanvas) ((mxImageCanvas) canvas).getGraphicsCanvas()).drawVertex(state, label);
				} else if (getModel().isVertex(state.getCell()) && canvas instanceof PeterSwingCanvas) {
					((PeterSwingCanvas) canvas).drawVertex(state, label);
				} else {
					super.drawState(canvas, state, drawLabel);
				}
			}

			@Override
			public boolean isPort(Object cell) {
				mxGeometry geo = getCellGeometry(cell);

				return (geo != null) ? geo.isRelative() : false;
			}

			@Override
			public String getToolTipForCell(Object cell) {
				if (model.isEdge(cell)) {
					return convertValueToString(model.getTerminal(cell, true)) + " -> " + convertValueToString(model.getTerminal(cell, false));
				}

				return super.getToolTipForCell(cell);
			}

			@Override
			public boolean isCellFoldable(Object cell, boolean collapse) {
				return false;
			}

			@Override
			public boolean isCellMovable(Object cell) {
				if (((mxCell) cell).getValue() instanceof Module) {
					return true;
				}
				return false;
			}

			@Override
			public boolean isCellEditable(Object cell) {
				return false;
			}

			@Override
			public boolean isCellResizable(Object cell) {
				return false;
			}

			@Override
			public String convertValueToString(Object c) {
				mxCell cell = (mxCell) c;
				if (cell.getValue() == null) {
					return null;
				} else if (cell.getValue() instanceof Port) {
					Port port = (Port) cell.getValue();
					return port.name + Objects.toString(port.range, "");
				} else if (cell.getValue() instanceof Module) {
					Module module = (Module) cell.getValue();
					return module.name;
				} else if (cell.getValue() instanceof Wire) {
					Wire wire = (Wire) cell.getValue();
					return wire.name;
				}
				return cell.getValue().toString();
			}
		};
		graph.setCellsDisconnectable(false);
		graph.setKeepEdgesInBackground(true);
		Map<String, Object> style = graph.getStylesheet().getDefaultEdgeStyle();
		style.put(mxConstants.STYLE_EDGE, mxEdgeStyle.OrthConnector);
//		style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_CURVE);
//		style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_CLASSIC);
		graphComponent = new MyGraphComponent(graph);
		graphComponent.getGraphControl().addMouseListener(new MouseAdapter() {

			@Override
			public void mouseClicked(MouseEvent e) {
				Object c = graphComponent.getCellAt(e.getX(), e.getY());
				if (c == null) {
					resetAllWiresColor();
					PeterSwingCanvas myCanvas = (PeterSwingCanvas) graphComponent.getCanvas();
					myCanvas.selectedCells.clear();
					graph.refresh();
					return;
				}
				mxCell cell = (mxCell) c;
				PeterSwingCanvas myCanvas = (PeterSwingCanvas) graphComponent.getCanvas();

				infoLabel.setText(null);
				wireLabel.setText(null);
				destLabel.setText(null);

				if (cell.getValue() instanceof Port) {
					myCanvas.selectedCells.clear();
					myCanvas.selectedCells.add(cell);
					Port port = (Port) cell.getValue();
					ArrayList<Wire> matchedWires = new ArrayList<>();
					for (Wire wire : topModule.wires.values()) {
						if (wire.ports.contains(port)) {
							matchedWires.add(wire);
						}
					}
					// highlight related ports
					for (Wire matchedWire : matchedWires) {
						for (Port p : matchedWire.ports) {
							mxCell tempCell = modulePortCells.get(new ImmutablePair(p.module.name, p.name));
							myCanvas.selectedCells.add(tempCell);
						}
					}
					// end highlight related ports

					resetAllWiresColor();

					// highlight related wires
					for (Wire matchedWire : matchedWires) {
						for (mxCell matchedWireCell : wireCells.get(matchedWire)) {
							matchedWireCell.setStyle(matchedWireCell.getStyle().replaceAll("strokeColor=#[0-9a-fA-F]{6}", "strokeColor=" + CommonLib.toHexColor(colorButton.getBackground())));
							matchedWireCell.setStyle(matchedWireCell.getStyle().replaceAll("fontColor=#[0-9a-fA-F]{6}", "fontColor=" + CommonLib.toHexColor(colorButton.getBackground())));
							matchedWireCell.setStyle(matchedWireCell.getStyle().replaceAll("strokeWidth=[0-9]+", "strokeWidth=5"));
						}
					}
					graph.refresh();
					// end highlight related wires

					for (Wire matchedWire : matchedWires) {
						String inputStr = "";
						String outputStr = "";
						for (Port p : matchedWire.ports) {
							if (p.direction.equals("input")) {
								if (!inputStr.equals("")) {
									inputStr += "<br />";
								}
								inputStr += p.module.name + " : " + p.name + Objects.toString(p.range, "");
							} else if (p.direction.equals("output")) {
								if (!outputStr.equals("")) {
									outputStr += "<br />";
								}
								outputStr += p.module.name + " : " + p.name + Objects.toString(p.range, "");
							}
						}
						inputStr = "<html><body>" + inputStr + "</body></html>";
						outputStr = "<html><body>" + outputStr + "</body></html>";
						infoLabel.setText(inputStr);
						wireLabel.setText(matchedWire.name);
						destLabel.setText(outputStr);
					}
				} else if (cell.getValue() instanceof Wire) {
					Wire matchedWire = (Wire) cell.getValue();
					infoLabel.setText(matchedWire.modules.get(0).name + " : " + matchedWire.ports.get(0).name + Objects.toString(matchedWire.ports.get(0).range, ""));
					wireLabel.setText(matchedWire.name);
					destLabel.setText(matchedWire.modules.get(1).name + " : " + matchedWire.ports.get(1).name);

					// highlight related ports
					for (Port p : matchedWire.ports) {
						mxCell tempCell = modulePortCells.get(new ImmutablePair(p.module.name, p.name));
						myCanvas.selectedCells.add(tempCell);
					}
					// end highlight related ports

					// reset all wires color
					for (Wire wire : topModule.wires.values()) {
						for (mxCell tempCell : wireCells.get(wire)) {
							tempCell.setStyle(tempCell.getStyle().replaceAll("strokeColor=#[0-9a-fA-F]{6}", "strokeColor=" + genColor(wire.name)));
							tempCell.setStyle(tempCell.getStyle().replaceAll("fontColor=#[0-9a-fA-F]{6}", "fontColor=" + genColor(wire.name)));
							tempCell.setStyle(tempCell.getStyle().replaceAll("strokeWidth=[0-9]+", "strokeWidth=1"));
						}
					}
					// end reset all wires color

					// highlight related wires
					for (mxCell matchedWireCell : wireCells.get(matchedWire)) {
						matchedWireCell.setStyle(matchedWireCell.getStyle().replaceAll("strokeColor=#[0-9a-fA-F]{6}", "strokeColor=" + CommonLib.toHexColor(colorButton.getBackground())));
						matchedWireCell.setStyle(matchedWireCell.getStyle().replaceAll("fontColor=#[0-9a-fA-F]{6}", "fontColor=" + CommonLib.toHexColor(colorButton.getBackground())));
						matchedWireCell.setStyle(matchedWireCell.getStyle().replaceAll("strokeWidth=[0-9]+", "strokeWidth=5"));
					}
					graph.refresh();
					// end highlight related wires
				}
			}

		});

		graphComponent.getGraphControl().addMouseMotionListener(new MouseMotionAdapter() {
			@Override
			public void mouseMoved(MouseEvent e) {
				Object cell = graphComponent.getCellAt(e.getX(), e.getY());
			}

		});
		mainPanel.removeAll();
		mainPanel.add(graphComponent, BorderLayout.CENTER);

		graphOutline = new mxGraphOutline(graphComponent);
		graphOutline.setPreferredSize(new Dimension(200, 200));
		graphOutline.setBackground(Color.red);
		graphOutline.setOpaque(true);
		jPanel1.add(graphOutline, BorderLayout.NORTH);
	}

	public void loadAllVerilog(File topModuleFile) {
		if (topModuleFile == null) {
			return;
		}
		try {
			boolean bingo = true;
			for (int x = 0; x < topModuleComboBox.getItemCount(); x++) {
				if (topModuleComboBox.getItemAt(x) == topModuleFile) {
					bingo = false;
					break;
				}
			}
			if (bingo) {
				topModuleComboBox.addItem(topModuleFile);
			}

			File folder = topModuleFile.getParentFile();
			System.out.println("loadAllVerilog() " + topModuleFile.getAbsolutePath());
			Collection<File> files = FileUtils.listFiles(folder, new String[]{"v"}, true);
			HashMap<String, hk.quantr.verilogcompiler.structure.Module> modules = new HashMap<>();
			for (File file : files) {
				System.out.println("parseTopModule(), processing " + file.getAbsolutePath());
				String content = IOUtils.toString(new FileInputStream(file), "utf-8");
				ParseStructure ps = new ParseStructure();
				String sourceContent = VerilogHelper.getContentReplacedWithMacro(1, file, content, VerilogHelper.scanMacroDefinitions(file, file.getParentFile()), ps);

				VerilogLexer lexer = new VerilogLexer(CharStreams.fromString(sourceContent));
				CommonTokenStream tokenStream = new CommonTokenStream(lexer);
				SingleModuleListener listener = new SingleModuleListener();
				VerilogParser parser = new VerilogParser(tokenStream);
				parser.addParseListener(listener);
				VerilogParser.Source_textContext context = parser.source_text();

				if (listener.moduleName == null) {
					continue;
				}

				modules.put(listener.moduleName, new hk.quantr.verilogcompiler.structure.Module(listener.moduleName, listener.inputs, listener.outputs));
			}
			System.out.println("----");

			// parse top module
			try {
				String content = IOUtils.toString(new FileInputStream(topModuleFile), "utf-8");
				ParseStructure ps = new ParseStructure();
				String sourceContent = VerilogHelper.getContentReplacedWithMacro(1, topModuleFile, content, VerilogHelper.scanMacroDefinitions(topModuleFile, topModuleFile.getParentFile()), ps);

				VerilogLexer lexer = new VerilogLexer(CharStreams.fromString(sourceContent));
				CommonTokenStream tokenStream = new CommonTokenStream(lexer);
				AllModuleListener listener = new AllModuleListener(modules);
				VerilogParser parser = new VerilogParser(tokenStream);
				parser.addParseListener(listener);
				VerilogParser.Source_textContext context = parser.source_text();

				topModule = new Module();
				topModule.name = listener.moduleName;
				topModule.modules = listener.modules;
				topModule.inputs = listener.inputs;
				topModule.outputs = listener.outputs;
				topModule.wires = listener.wires;
			} catch (IOException ex) {
				ex.printStackTrace();
			}

			///////
			initModuleList(topModule);
			initJGraphComponent(topModule);
		} catch (Exception ex) {
			ex.printStackTrace();
			System.out.println(ex.getMessage());
		}
	}

	public String getModuleName(String portName) {
		for (ImmutablePair<String, String> key : modulePortCells.keySet()) {
			if (key.right.equals(portName)) {
				return key.left;
			}
		}
		return null;
	}

	private void initModuleList(Module topModule) {
		DefaultListModel listModel = new DefaultListModel();
		for (String moduleName : topModule.modules.keySet()) {
			listModel.addElement(topModule.modules.get(moduleName));
		}
		moduleList.setModel(listModel);
		moduleList.setSelectionInterval(0, listModel.getSize() - 1);
	}

	public String genColor(String str) {
		String color = String.format("#%06X", str.hashCode()).substring(0, 7);
		return color;
	}

	private void initJGraphComponent(Module topModule) {
		if (topModule == null) {
			return;
		}
		Object parent = graph.getDefaultParent();
		graph.removeCells(graph.getChildVertices(graph.getDefaultParent()));
		graph.getModel().beginUpdate();
		int x = 100;
		final int PORT_HEIGHT = 30;
		final int MODULE_TOP_PADDING = 40;
		final int MODULE_WIDTH = 160;
		final int SPACE = 100;
		moduleCells.clear();
		modulePortCells.clear();
		modulePortPorts.clear();
		wireCells.clear();
		for (String moduleName : topModule.modules.keySet()) {
			if (!moduleList.getSelectedValuesList().contains(topModule.modules.get(moduleName))) {
				continue;
			}
			Module module = topModule.modules.get(moduleName);
			int MODULE_HEIGHT = ((module.inputs.size() + module.outputs.size()) * PORT_HEIGHT) + 20;
			mxCell v1 = (mxCell) graph.insertVertex(parent, module.name, module, x, 80, MODULE_WIDTH, MODULE_HEIGHT, "z-index:1000;strokeWidth=0;strokeColor=#0f5ea2;fillColor=#b8deff;fontColor=black;fontSize=18;verticalLabelPosition=top;verticalAlign=bottom");
			v1.setConnectable(false);
			moduleCells.put(module.name, v1);

			ArrayList<mxCell> cells = new ArrayList<>();

			float pos = MODULE_TOP_PADDING;
			for (Port port : module.inputs) {
				mxGeometry geoVertical = new mxGeometry(0, pos, MODULE_WIDTH, PORT_HEIGHT);
				mxCell leftPort = new mxCell(port, geoVertical, "strokeWidth=0;shape=rectangle;strokeColor=#0f5ea2;fillColor=#d8eeff;fontSize=12;fontColor=black;portConstraint=eastwest;");
				leftPort.setVertex(true);
				leftPort.setConnectable(false);
				modulePortCells.put(new ImmutablePair(module.name, port.name), leftPort);
				modulePortPorts.put(new ImmutablePair(module.name, port.name), port);
				graph.addCell(leftPort, v1);
				pos += PORT_HEIGHT;

				cells.add(leftPort);
			}

			for (Port port : module.outputs) {
				mxGeometry geoVertical = new mxGeometry(0, pos, MODULE_WIDTH, PORT_HEIGHT);
				mxCell rightPort = new mxCell(port, geoVertical, "strokeWidth=0;shape=rectangle;strokeColor=#0f5ea2;fillColor=#ffeed8;fontSize=12;fontColor=black;portConstraint=eastwest;");
				rightPort.setVertex(true);
				rightPort.setConnectable(false);
				modulePortCells.put(new ImmutablePair(module.name, port.name), rightPort);
				modulePortPorts.put(new ImmutablePair(module.name, port.name), port);
				graph.addCell(rightPort, v1);
				pos += PORT_HEIGHT;

				cells.add(rightPort);
			}

			mxCell vertex = new mxCell(null, new mxGeometry(0, 0, MODULE_WIDTH, PORT_HEIGHT), null);
			vertex.setVertex(true);
			graph.groupCells(vertex, 0, cells.toArray());

			x += MODULE_WIDTH + SPACE;
		}

		// add all wires
		int wireNo = 0;
		for (String wireName : topModule.wires.keySet()) {
			Wire wire = topModule.wires.get(wireName);
			for (int z = 0; z < wire.ports.size(); z++) {
				for (int y = 0; y < wire.ports.size(); y++) {
					Port port1 = null;
					Port port2 = null;
					Module module1 = null;
					Module module2 = null;
					if (wire.ports.get(z).direction.equals("input") && wire.ports.get(y).direction.equals("output")) {
						port1 = wire.ports.get(z);
						port2 = wire.ports.get(y);
						module1 = wire.modules.get(z);
						module2 = wire.modules.get(y);
					} else if (wire.ports.get(z).direction.equals("output") && wire.ports.get(y).direction.equals("input")) {
						port1 = wire.ports.get(y);
						port2 = wire.ports.get(z);
						module1 = wire.modules.get(y);
						module2 = wire.modules.get(z);
					}

					if (port1 != null && port2 != null) {
						System.out.println(String.format("adding wire %-30s, %-30s <-> %-30s\t,\t", wire.name, module1.name + "(" + port1.name + ")", module2.name + "(" + port2.name + ")"));
						mxCell port1Cell = modulePortCells.get(new ImmutablePair(module1.name, port1.name));
						mxCell port2Cell = modulePortCells.get(new ImmutablePair(module2.name, port2.name));

						String color = genColor(wire.name);
						if (port1.direction.equals("input")) {
							mxCell edge = (mxCell) graph.insertEdge(parent, "wire_" + wireNo, wire, port2Cell, port1Cell, "fontSize=" + fontSizeComboBox.getSelectedItem() + ";fontColor=" + color + ";strokeColor=" + color + ";strokeWidth=1");
							edge.getGeometry().setOffset(new mxPoint(-100, -30));
							if (wireCells.get(wire) == null) {
								wireCells.put(wire, new ArrayList<>(Arrays.asList(edge)));
							} else {
								wireCells.get(wire).add(edge);
							}
						} else {
							mxCell edge = (mxCell) graph.insertEdge(parent, "wire_" + wireNo, wire, port1Cell, port2Cell, "fontSize=" + fontSizeComboBox.getSelectedItem() + ";fontColor=" + color + ";strokeColor=" + color + ";strokeWidth=1");
							edge.getGeometry().setOffset(new mxPoint(-100, -30));
							if (wireCells.get(wire) == null) {
								wireCells.put(wire, new ArrayList<>(Arrays.asList(edge)));
							} else {
								wireCells.get(wire).add(edge);
							}
						}
						wireNo++;
					}
				}
			}
		}

		Map<String, Object> style = graph.getStylesheet().getDefaultEdgeStyle();
		style.put(mxConstants.STYLE_EDGE, mxEdgeStyle.ElbowConnectorPreventOverlap);
		graph.getModel().endUpdate();
	}
}
